package main

// #cgo CFLAGS: -I../../ts3client-pluginsdk/include -I../c
// #cgo LDFLAGS: -Wl,-unresolved-symbols=ignore-all
// #include <stdlib.h>
// #include "teamspeak/public_errors.h"
// #include "teamspeak/public_errors_rare.h"
// #include "teamspeak/public_definitions.h"
// #include "teamspeak/public_rare_definitions.h"
// #include "teamspeak/clientlib_publicdefinitions.h"
// #include "plugin_definitions.h"
// extern void Ts3FncPrintMessage(uint64 serverConnectionHandlerID, const char* message, enum PluginMessageTarget messageTarget);
import "C"
import (
	tsgo "./tsgo"
)

func main() {} // Required if you want to export functions

/*
	Required functions.
*/

//export GoTs3pluginName
func GoTs3pluginName() *C.char {
	return C.CString(tsgo.Ts3pluginName())
}

//export GoTs3pluginVersion
func GoTs3pluginVersion() *C.char {
	return C.CString(tsgo.Ts3pluginVersion())
}

//export GoTs3pluginAPIVersion
func GoTs3pluginAPIVersion() C.int {
	return C.int(tsgo.Ts3pluginAPIVersion())
}

//export GoTs3pluginAuthor
func GoTs3pluginAuthor() *C.char {
	return C.CString(tsgo.Ts3pluginAuthor())
}

//export GoTs3pluginDescription
func GoTs3pluginDescription() *C.char {
	return C.CString(tsgo.Ts3pluginDescription())
}

//export GoTs3pluginInit
func GoTs3pluginInit() C.int {
	return C.int(tsgo.Ts3pluginInit())
}

//export GoTs3pluginShutdown
func GoTs3pluginShutdown() {
	tsgo.Ts3pluginShutdown()
}

/*
	Not so required functions
*/

//export GoTs3onClientPokeEvent
func GoTs3onClientPokeEvent(serverConnectionHandlerID C.uint64, fromClientID C.anyID, pokerName *C.char, pokerUniqueIdentity *C.char, message *C.char, ffIgnored int) C.int {
	C.Ts3FncPrintMessage(serverConnectionHandlerID, C.CString("Ayyyy"), C.PLUGIN_SERVER)
	return 1
}
